## quantlib 1.9.1

=== CMakeLists.txt ===
cmake_minimum_required()

# to reference headers via <ql/foo.hpp>, we need to add the root
# directory of the project to includes
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

find_package(Boost)
if (Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
endif (Boost_FOUND)

add_subdirectory(Examples)
add_subdirectory(ql)

# Building the test suite might require using shared libraries
# for Boost.Test
option(USE_BOOST_DYNAMIC_LIBRARIES
       "Use the shared version of Boost.Test" OFF)
add_subdirectory(test-suite)

=== Examples/CMakeLists.txt ===
add_subdirectory(BasketLosses)
add_subdirectory(BermudanSwaption)
add_subdirectory(Bonds)
add_subdirectory(CallableBonds)
add_subdirectory(CDS)
add_subdirectory(ConvertibleBonds)
add_subdirectory(CVAIRS)
add_subdirectory(DiscreteHedging)
add_subdirectory(EquityOption)
add_subdirectory(FittedBondCurve)
add_subdirectory(FRA)
add_subdirectory(Gaussian1dModels)
add_subdirectory(LatentModel)
add_subdirectory(MarketModels)
add_subdirectory(MultidimIntegral)
add_subdirectory(Replication)
add_subdirectory(Repo)
add_subdirectory(Swap)

=== ql/CMakeLists.txt ===
file(GLOB_RECURSE QUANTLIB_FILES "*.hpp" "*.cpp")
add_library(QuantLib SHARED ${QUANTLIB_FILES})

=== test-suite/CMakeLists.txt ===
file (GLOB TEST_SUITE_FILES "*.hpp" "*.cpp")

# these do not appear in vcproj
list(REMOVE_ITEM TEST_SUITE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/quantlibbenchmark.cpp)

if (USE_BOOST_DYNAMIC_LIBRARIES)
   add_definitions(-DBOOST_TEST_DYN_LINK)
endif (USE_BOOST_DYNAMIC_LIBRARIES)

find_package (Boost COMPONENTS unit_test_framework REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
set (TEST quantlib-test-suite)
add_executable (${TEST} ${TEST_SUITE_FILES})
target_link_libraries (${TEST} QuantLib ${Boost_LIBRARIES})
enable_testing ()
add_test (${TEST} ${TEST})

=== Examples/BasketLosses/CMakeLists.txt ===
add_executable(BasketLosses BasketLosses.cpp)
target_link_libraries(BasketLosses QuantLib)

=== Examples/BermudanSwaption/CMakeLists.txt ===
add_executable(BermudanSwaption BermudanSwaption.cpp)
target_link_libraries(BermudanSwaption QuantLib)

=== Examples/Bonds/CMakeLists.txt ===
add_executable(Bonds Bonds.cpp)
target_link_libraries(Bonds QuantLib)

=== Examples/CDS/CMakeLists.txt ===
add_executable(CDS CDS.cpp)
target_link_libraries(CDS QuantLib)

=== Examples/CVAIRS/CMakeLists.txt ===
add_executable(CVAIRS CVAIRS.cpp)
target_link_libraries(CVAIRS QuantLib)

=== Examples/CallableBonds/CMakeLists.txt ===
add_executable(CallableBonds CallableBonds.cpp)
target_link_libraries(CallableBonds QuantLib)

=== Examples/ConvertibleBonds/CMakeLists.txt ===
add_executable(ConvertibleBonds ConvertibleBonds.cpp)
target_link_libraries(ConvertibleBonds QuantLib)

=== Examples/DiscreteHedging/CMakeLists.txt ===
add_executable(DiscreteHedging DiscreteHedging.cpp)
target_link_libraries(DiscreteHedging QuantLib)

## quantlib 1.10

=== Examples/GlobalOptimizer/CMakeLists.txt ===
add_executable(GlobalOptimizer GlobalOptimizer.cpp)
target_link_libraries(GlobalOptimizer QuantLib)

## quantlib 1.12

=== CMakeLists.txt ===
cmake_minimum_required()

project(QuantLib)

include(${CMAKE_CURRENT_LIST_DIR}/cmake/quantlib.cmake)

option(BUILD_SHARED_LIBS "Build shared libraries" ${UNIX})
option(USE_BOOST_DYNAMIC_LIBRARIES "Use the shared version of Boost libraries" ${UNIX})
if (USE_BOOST_DYNAMIC_LIBRARIES)
    add_definitions(-DBOOST_ALL_DYN_LINK)
else()
    set(Boost_USE_STATIC_LIBS ON)
endif()

if (MSVC)
    set(MSVC_RUNTIME "dynamic" CACHE STRING "MSVC runtime to link")
    set_property(CACHE MSVC_RUNTIME PROPERTY STRINGS static dynamic)
    configure_msvc_runtime()

    if(${MSVC_RUNTIME} STREQUAL "static")
        if(USE_BOOST_DYNAMIC_LIBRARIES)
            message(FATAL_ERROR "Use of shared Boost libraries while compiling with static runtime seems not be a good idea.")
        endif()
        set(Boost_USE_STATIC_RUNTIME ON)
    endif()

    # Remove warnings
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
endif()

# On single-configuration builds, select a default build type that
# gives the same compilation flags as a default autotools build.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

# to reference headers via <ql/foo.hpp>, we need to add the root
# directory of the project to includes
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

find_package(Boost)
if (Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
endif (Boost_FOUND)

add_subdirectory(ql)
add_subdirectory(Examples)
add_subdirectory(test-suite)

#
# Copy across the ANSI config file into the build directory. Users
# need to change userconfig.hpp if they require different settings.
#
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ql/config.ansi.hpp
  ${PROJECT_BINARY_DIR}/config.hpp COPYONLY)
install(FILES ${PROJECT_BINARY_DIR}/config.hpp DESTINATION include/ql)

=== Examples/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 add_subdirectory(FittedBondCurve)
 add_subdirectory(FRA)
 add_subdirectory(Gaussian1dModels)
+add_subdirectory(GlobalOptimizer)
 add_subdirectory(LatentModel)
 add_subdirectory(MarketModels)
 add_subdirectory(MultidimIntegral)

=== ql/CMakeLists.txt ===

get_quantlib_library_name(QL_OUTPUT_NAME)


file(GLOB_RECURSE QUANTLIB_FILES "*.hpp" "*.cpp")
if(WIN32)
    if (${BUILD_SHARED_LIBS})
        # Windows needs to link static library (nothing is declared to export in QuantLib)
        message(FATAL_ERROR "You should build QuantLib in STATIC mode as nothing is exported from the library. Use BUILD_SHARED_LIBS=OFF")
    endif()
    add_library(${QL_OUTPUT_NAME} ${QUANTLIB_FILES})
    set_property(TARGET ${QL_OUTPUT_NAME} PROPERTY PROJECT_LABEL "QuantLib")
else()
    add_library(${QL_OUTPUT_NAME} ${QUANTLIB_FILES})
endif()
set(QL_LINK_LIBRARY ${QL_OUTPUT_NAME} PARENT_SCOPE)


install(DIRECTORY . DESTINATION include/ql
        FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h")

install(TARGETS ${QL_OUTPUT_NAME}
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
        )

=== test-suite/CMakeLists.txt ===
file (GLOB TEST_SUITE_FILES "*.hpp" "*.cpp")
set(BENCHMARK_FILES "main.cpp" "quantlibbenchmark.cpp" "americanoption.cpp" "asianoptions.cpp" "barrieroption.cpp"
       "basketoption.cpp" "batesmodel.cpp" "convertiblebonds.cpp" "digitaloption.cpp" "dividendoption.cpp"
       "europeanoption.cpp" "fdheston.cpp" "hestonmodel.cpp" "interpolations.cpp" "jumpdiffusion.cpp"
       "marketmodel_smm.cpp" "marketmodel_cms.cpp" "lowdiscrepancysequences.cpp" "quantooption.cpp" "riskstats.cpp"
       "shortratemodels.cpp" "utilities.cpp" "utilities.hpp" "swaptionvolstructuresutilities.hpp")

# these do not appear in vcproj
list(REMOVE_ITEM TEST_SUITE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/quantlibbenchmark.cpp)

if (USE_BOOST_DYNAMIC_LIBRARIES)
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif()

find_package (Boost COMPONENTS unit_test_framework REQUIRED)

set (TEST quantlib-test-suite)
add_executable (${TEST} ${TEST_SUITE_FILES})
target_link_libraries (${TEST} ${QL_LINK_LIBRARY} ${Boost_LIBRARIES})
set_property(TARGET ${TEST} PROPERTY PROJECT_LABEL "testsuite")

set (BENCHMARK quantlib-benchmark)
add_executable (${BENCHMARK} ${BENCHMARK_FILES})
target_link_libraries (${BENCHMARK} ${QL_LINK_LIBRARY} ${Boost_LIBRARIES})
set_property(TARGET ${BENCHMARK} PROPERTY PROJECT_LABEL "benchmark")

enable_testing ()
add_test (${TEST} ${TEST})

=== Examples/BasketLosses/CMakeLists.txt ===
add_executable(BasketLosses BasketLosses.cpp)
target_link_libraries(BasketLosses ${QL_LINK_LIBRARY})

=== Examples/CallableBonds/CMakeLists.txt ===
add_executable(CallableBonds CallableBonds.cpp)
target_link_libraries(CallableBonds ${QL_LINK_LIBRARY})

=== Examples/ConvertibleBonds/CMakeLists.txt ===
add_executable(ConvertibleBonds ConvertibleBonds.cpp)
target_link_libraries(ConvertibleBonds ${QL_LINK_LIBRARY})

=== Examples/Repo/CMakeLists.txt ===
add_executable(Repo Repo.cpp)
target_link_libraries(Repo ${QL_LINK_LIBRARY})

=== Examples/Swap/CMakeLists.txt ===
add_executable(SwapValuation swapvaluation.cpp)
target_link_libraries(SwapValuation ${QL_LINK_LIBRARY})

## quantlib 1.13

=== debian/changelog ===
quantlib (1.13-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:03:01 +0000

quantlib (1.13-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 24 May 2018 11:08:21 -0500

quantlib (1.12.1-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 16 Apr 2018 07:01:21 -0500

quantlib (1.12-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 01 Feb 2018 05:56:04 -0600

quantlib (1.11-4) unstable; urgency=medium

  * debian/control: Version the Breaks: + Replace:	(Closes: #881411)

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 11 Nov 2017 08:41:08 -0600

quantlib (1.11-3) unstable; urgency=medium

  * debian/control: Add Breaks: and Replaces: to quantlib-examples as 
    CVAIRS binary moved packages			(Closes: #88040)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 09 Nov 2017 20:40:57 -0600

quantlib (1.11-2.trusty.0) trusty; urgency=medium

  * PPA build for Ubuntu 14.04 ("trusty")
  * debian/control: Temporarily remove 'g++ (>= 4:5.2)' constraint

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 14 Oct 2017 18:06:03 -0500

quantlib (1.11-2.zesty.0) zesty; urgency=medium

  * PPA build for Ubuntu 17.04 ("zesty")

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 14 Oct 2017 13:13:39 -0500

quantlib (1.11-2) unstable; urgency=medium

  * debian/quantlib-examples.files: Updated for additional examples and manual pages
  * man/GlobalOptimizer.1: New contributed manual page, also sent upstrea,
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 13 Oct 2017 13:37:11 -0500

quantlib (1.11-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 02 Oct 2017 06:30:57 -0500

quantlib (1.10.1-2) unstable; urgency=medium

  * debian/rules: Also exclude mips64el from checks (with thanks to Adrian Bunk)

  * debian/rules: Fix (older) typo which creates an error under current debhelper
    (also with thanks to Adrian Bunk for the bug report)	(Closes: #876569)
    
 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 26 Sep 2017 16:06:22 -0500

quantlib (1.10.1-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Update Standards-Version: to current version

  * debian/compat: Increase to 9

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 31 Aug 2017 14:32:52 -0500

quantlib (1.10-1trusty1) trusty; urgency=medium

  * PPA build for Ubuntu 14.04 ("trusty")
  * debian/control: Temporarily remove 'g++ (>= 4:5.2)' constraint

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 16 May 2017 20:55:43 -0500

quantlib (1.10-1xenial1) xenial; urgency=medium

  * PPA build for Ubuntu 16.04 ("xenial")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 16 May 2017 12:38:56 -0500

quantlib (1.10-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 16 May 2017 06:45:36 -0500

quantlib (1.9-2) unstable; urgency=medium

  * ql/experimental/termstructures/multicurvesensitivities.hpp: Added five
    missing 'inline' declarations (also sent upstream as PR 161)

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 15 Nov 2016 06:56:36 -0600

quantlib (1.9-1xenial2) xenial; urgency=medium

  * PPA build for Ubuntu 16.04 ("xenial")

  * ql/experimental/termstructures/multicurvesensitivities.hpp: Added five
    missing 'inline' declarations (also sent upstream as PR 161)
    
 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 14 Nov 2016 21:37:32 -0600

quantlib (1.9-1xenial1) xenial; urgency=medium

  * PPA build for Ubuntu 16.04 ("xenial")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 08 Nov 2016 09:19:30 -0600

quantlib (1.9-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 08 Nov 2016 06:20:21 -0600

quantlib (1.8.1-1xenial1) xenial; urgency=medium

  * PPA build for Ubuntu 16.04 ("xenial")
  * debian/control: Temporarily remove 'g++ (>= 4:5.2)' constraint

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 30 Sep 2016 22:41:00 -0500

quantlib (1.8.1-1trusty1) trusty; urgency=medium

  * PPA build for Ubuntu 14.04 ("trusty")
  * debian/control: Temporarily remove 'g++ (>= 4:5.2)' constraint

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 29 Sep 2016 19:58:10 -0500

quantlib (1.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 25 Sep 2016 09:45:17 -0500

quantlib (1.8-1trusty1) trusty; urgency=medium

  * PPA build for Ubuntu 14.04 ("trusty")
  * debian/control: Temporarily remove 'g++ (>= 4:5.2)' constraint

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 27 May 2016 12:12:49 -0500

quantlib (1.8-1xenial0) xenial; urgency=medium

  * PPA build for Ubuntu 16.04 ("xenial")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 18 May 2016 16:31:44 -0500

quantlib (1.8-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 18 May 2016 06:23:15 -0500

quantlib (1.8~20160419-1) unstable; urgency=medium

  [unreleased]
  * Release candidate for 1.8 as of 2016-04-19

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 21 Apr 2016 07:27:34 -0500

quantlib (1.7.1-1) unstable; urgency=low

  * New upstream release

  * debian/control: Remove libboost-thread-dev from Build-Depends: as it
    only crept in by (upstream) accident which is now rectified

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 18 Jan 2016 11:23:10 -0600

quantlib (1.7-2) unstable; urgency=low

  * debian/rules: Also suppress tests on 'aarch64' 	(Closes: #806705)

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 30 Nov 2015 08:01:31 -0600

quantlib (1.7-1wily0) wily; urgency=low

  * PPA build for Ubuntu 15.10 ("wily")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 25 Nov 2015 08:29:10 -0600



=== debian/control ===
Source: quantlib
Section: libs
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: debhelper (>= 7.0), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, g++ (>= 4:5.2), dh-autoreconf
Standards-Version: 4.1.4

Package: libquantlib0v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks:  libquantlib-1.1, libquantlib-1.0.0
Replaces: libquantlib-1.2, libquantlib-1.1, libquantlib-1.0.0, libquantlib0
Conflicts: libquantlib0
Provides: libquantlib-1.2, libquantlib-1.1, libquantlib-1.0.0
Description: Quantitative Finance Library -- library package
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package provides the shared libraries required to run programs 
 compiled with QuantLib.

Package: libquantlib0-dev
Architecture: any
Section: libdevel
Replaces: libquantlib0, libquantlib-0.3.9
Depends: ${shlibs:Depends}, ${misc:Depends}, libc6-dev, libboost-test-dev, libquantlib0v5 (= ${binary:Version})
Description: Quantitative Finance Library -- development package
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package contains the header files, static libraries and symbolic 
 links that developers using QuantLib will need.

Package: quantlib-examples
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends}, libquantlib0v5 (= ${binary:Version})
Breaks: libquantlib0v5 (<< 1.11-2)
Replaces: libquantlib0v5 (<< 1.11-2)
Description: Quantitative Finance Library -- example binaries
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package provides several example binaries as well as source code.

=== debian/rules ===
#!/usr/bin/make -f
#                                                       -*- makefile -*-
# debian/rules file for the Debian/GNU Linux quantlib package
# Copyright (C) 2001 - 2016 by Dirk Eddelbuettel <edd@debian.org>

source  := $(shell head -1 debian/changelog | awk '{print $$1}')
# 'quantlib-config --version' after configure is easier ...

# that currently gets 1.0 only
# reverted back to using libquantlib0
#sonum   := 1.3
#sonum	:= $(shell grep AC_INIT configure.ac | \
#			perl -ne 'm/([0-9\\.]+)/ and print $$1')
#libpkg  := lib$(source)-$(sonum)
#libpkg  := lib$(source)-1.1
libpkg  := lib$(source)0v5

devpkg  := lib$(source)0-dev
smppkg  := $(source)-examples
debtmp	:= $(CURDIR)/debian/$(libpkg)
libdoc	:= $(CURDIR)/debian/$(libpkg)/usr/share/doc/$(libpkg)
arch 	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
cpu	:= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

#export DH_VERBOSE=1

## edd 29 Nov 2001	Default to g++
## edd 18 Jun 2005 	g++-3.4 for testing
## edd 18 Jul 2005      back to g++
## edd 17 Nov 2005	g++-4.0
## edd 16 Mar 2006      back to g++
cxx	= g++

## edd 13 Apr 2014	use dpkg-buildflags as a base
cxxbuildflags   = 	$(shell dpkg-buildflags --get CXXFLAGS)
cppbuildflags   = 	$(shell dpkg-buildflags --get CPPFLAGS)
buildflags      =       $(cxxbuildflags) $(cppbuildflags)
ldflags  =	 	$(shell dpkg-buildflags --get LDFLAGS)

## edd 18 May 2002	standard flags for libraries
## edd 18 Jun 2005 	no optim., debugging
## edd 18 Jul 2005	back to normal
## edd 17 Nov 2005	added -fpermissive for 0.3.11-2
## edd 13 Apr 2014      use buildflags as base
compilerflags   = $(buildflags) -g0 -O2 -D_REENTRANT -fpermissive

# edd 14 Jan 2003  no longer override g++ as 3.2 is now default everywhere
## 			but use g++-3.0 on ia64
#ifneq "$(findstring $(arch), ia64-linux)" ""
#cxx	= g++-3.0
#endif

## edd 18 May 2002	no optimisation or debugging on baby systems
## edd 14 May 2005	don't do it on mipsel or mips either
## edd 26 Jun 2007 	use cpu test, not arch test -- thanks to Riku via #430709
## edd 13 Apr 2014      use buildflags as base
## edd 18 May 2017      add mipsel64
## bunk 25 Sep 2017     comment out, all buildds are now able to build with -O2
#ifneq "$(findstring $(cpu), m68k arm armeb mipsel mips mipsel64)" ""
#compilerflags   = $(buildflags) -O0 -g0 -D_REENTRANT -fpermissive
#endif

### edd 22 Dec 2002  g++-3.2 for s390
#ifneq "$(findstring $(arch), s390-linux)" ""
#cxx	= g++-3.2
#endif

## edd 19 June 2004	no optimisation on amd64 (#255100)
#ifneq "$(findstring $(arch), x86_64-linux)" ""
#compilerflags   = -O0 -D_REENTRANT
#endif

upstream: get-orig-source	
get-orig-source: 
        #lynx http://quantlib.org/download.html
        #lynx http://prdownloads.sf.net/quantlib
	links http://quantlib.org/download.shtml

prerelease:
#	links http://quantlib.org/gm/
#	links http://quantlib.org/prerelease
	links https://sourceforge.net/projects/quantlib/files/prerelease

configure: configure-stamp
configure-stamp: 
	dh_testdir
	dh_autoreconf
        #./autogen.sh
	CXX=$(cxx) 						\
	CXXFLAGS="$(compilerflags)"				\
	CFLAGS="$(compilerflags)"				\
	LDFLAGS="$(ldflags)"                                    \
	./configure 	--prefix=/usr 				\
			--enable-openmp   			\
			--enable-intraday			\
			--enable-examples			\
			--enable-benchmark			\
			--enable-shared 			\
			--enable-static 			\
			--with-gnu-ld 				\
			--mandir=$(debtmp)/usr/share/man 	\
			--build $(arch)
        # patch libtool re rpath (see lintian docu)
	sed < libtool > libtool-2 \
			-e 's/^hardcode_libdir_flag_spec.*$$/hardcode_libdir_flag_spec=" -D__LIBTOOL_IS_A_FOOL__ "/' \
			-e '/^archive_cmds="/s/"$$/ \\$$deplibs"/'
	mv libtool-2 libtool
	chmod 755 libtool            
        # end libtool rpath patch
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	-$(MAKE) 	CFLAGS="$(compilerflags)"  	\
			CXXFLAGS="$(compilerflags)"  	\
			LDFLAGS="$(ldflags)"            \
			CXX=$(cxx)

        # edd 17 May 2005  create shlibs on the fly
        # edd 11 Feb 2007  libQuantLibFunctions is no more
	# edd 07 Mar 2012  need to tag this as so number 0
	# edd 01 Sep 2013  back to libquantlib0 and fixed file
	#@echo "libQuantLib ${sonum} libquantlib-${sonum}" \
	#	> debian/libquantlib-${sonum}.shlibs
	#@echo "libQuantLib 0 libquantlib-${sonum}" \
	#	> debian/shlibs.local
        #@echo "libQuantLibFunctions ${sonum} libquantlib-${sonum}" \
        #	>> debian/libquantlib-${sonum}.shlibs

	touch build-stamp

test:	test-stamp 
test-stamp: build-stamp
ifeq "$(findstring $(cpu), m68k arm aarch64 armeb armel mipsel mips mips64el hppa)" ""
	-LD_LIBRARY_PATH=$(CURDIR)/ql/.libs $(MAKE) check
        #-LD_LIBRARY_PATH=$(CURDIR)/ql/.libs $(MAKE) benchmark
endif
	touch test-stamp

clean:
	dh_testdir
	dh_testroot
	dh_autoreconf_clean
	rm -f configure-stamp build-stamp install-stamp test-stamp 
	rm -rf debian/static/
	dh_clean lib/*so* build/*.so*
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -rf config.log config.status
	#-rm -rf debian/libquantlib-${sonum}.shlibs

install: install-stamp 
install-stamp: test-stamp
	$(MAKE) -f debian/rules DH_OPTIONS= install-work
install-work:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	-$(MAKE) prefix=$(debtmp)/usr	 	  install
	-$(MAKE) prefix=$(debtmp)/usr	 	  install-am
        # clean usr/aclocal
	rm -rvf 	$(debtmp)/usr/aclocal
	dh_installexamples	-p$(libpkg)	Examples/ 	\
						test-suite/	\
						quantlib.el
	(cd $(libdoc)/examples/Examples; 			\
		rm -vf  */*.o */*.dsp */*.mak *.dsw *.mak;	\
		rm -rvf */.deps/ */.libs/;			\
		find . -type f -perm 0755 | xargs rm -vf ) || true
	(cd $(libdoc)/examples/test-suite; 			\
		rm -rvf  *.o .deps/ .libs/;			\
		find . -type f -perm 0755 | xargs rm -vf ) || true
#	dh_installman	-p$(devpkg)	debian/quantlib-test-suite.1 
        # now part of upstream: debian/DiscreteHedging.1 \
        #                       debian/quantlib-config.1 \
        # defunct		debian/Parities.1 	  
#	dh_installdirs 	-p$(smppkg) 	usr/share/man/man1
#	dh_installman	-p$(smppkg)	debian/EquityOption.1 \
#					debian/ConvertibleBonds.1
#	dh_installman	-p$(smppkg)	debian/FittedBondCurve.1
#	dh_installman	-p$(smppkg)	debian/CDS.1 debian/CallableBonds.1
        # install -d debian/libquantlib0/usr/bin
        # install -m 0755 -c quantlib-config debian/libquantlib0/usr/bin
        # move static libs into dev-package
	dh_movefiles 	-p$(devpkg) --sourcedir=debian/$(libpkg)
        # move example files into smp-package
	dh_movefiles 	-p$(smppkg) --sourcedir=debian/$(libpkg)
        # some cleanup after movefiles
	-rm -vf  	$(debtmp)/usr/lib/lib*.la
	-rm -rvf 	$(debtmp)/usr/include
	-rm -rvf	$(debtmp)/usr/share/doc/$(libpkg)/examples/
        # install lintian "silencer"
        # edd 15 May 2005  no longer needed	#       
        #dh_installdirs -p$(libpkg) usr/share/lintian/overrides
        #install -p -m 0644  debian/$(libpkg).lintian \
        #	$(debtmp)/usr/share/lintian/overrides/$(libpkg)
        # remove redundant LGPL license
	rm -vf 	$(CURDIR)/debian/$(devpkg)/usr/share/doc/$(libpkg)/examples/test-suite/CPPUNIT-COPYING
        # try this here
	dh_installchangelogs	-p$(libpkg) -N$(devpkg) -N$(smppkg) ChangeLog.txt
        # remove empty examples/ dir
#	rm -vf 	$(CURDIR)/debian/$(devpkg)/usr/share/doc/$(libpkg)/examples/test-suite/CPPUNIT-COPYING
	touch install-stamp

# This single target is used to build all the packages, all at once, or
# one at a time. So keep in mind: any options passed to commands here will
# affect _all_ packages. Anything you want to only affect one package
# should be put in another target, such as the install target.
binary-common: build test install 
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_link			-p$(smppkg) -p$(devpkg)
	dh_installdocs		-p$(libpkg) -N$(devpkg) -N$(smppkg)	\
						Readme.txt  		\
						Contributors.txt 	\
						News.txt
#	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
#	dh_installcron

=== debian/watch ===
version=3
http://sf.net/quantlib/ QuantLib-(.+)\.tar\.gz

## quantlib 1.15

=== Examples/FittedBondCurve/CMakeLists.txt ===
add_executable(FittedBondCurve FittedBondCurve.cpp)
target_link_libraries(FittedBondCurve ${QL_LINK_LIBRARY})

=== Examples/GlobalOptimizer/CMakeLists.txt ===
add_executable(GlobalOptimizer GlobalOptimizer.cpp)
target_link_libraries(GlobalOptimizer ${QL_LINK_LIBRARY})

=== Examples/Replication/CMakeLists.txt ===
add_executable(Replication Replication.cpp)
target_link_libraries(Replication ${QL_LINK_LIBRARY})

=== debian/changelog ===
quantlib (1.15-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Update Standards-Version: to current version

  * debian/quantlib-examples: Do not install SwapValuation and man page

  * debian/rules: Changed to install NEWS.md and not NEWS.txt

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 19 Feb 2019 05:55:23 -0600

quantlib (1.14-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 01 Oct 2018 21:03:37 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper (>= 7.0), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, g++ (>= 4:5.2), dh-autoreconf
-Standards-Version: 4.1.4
+Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, g++ (>= 4:5.2), dh-autoreconf
+Standards-Version: 4.3.0
 
 Package: libquantlib0v5
 Architecture: any

## quantlib 1.16

=== debian/changelog ===
quantlib (1.16-1) unstable; urgency=medium

  * New upstream release candidate

  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 05 Aug 2019 05:47:09 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
 Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, g++ (>= 4:5.2), dh-autoreconf
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 
 Package: libquantlib0v5
 Architecture: any

## quantlib 1.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,7 @@
 # directory of the project to includes
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
-find_package(Boost)
+find_package(Boost 1.48.0)
 if (Boost_FOUND)
   include_directories(${Boost_INCLUDE_DIRS})
 endif (Boost_FOUND)

=== test-suite/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
     add_definitions(-DBOOST_TEST_DYN_LINK)
 endif()
 
-find_package (Boost COMPONENTS unit_test_framework REQUIRED)
+find_package (Boost COMPONENTS unit_test_framework timer system REQUIRED)
 
 set (TEST quantlib-test-suite)
 add_executable (${TEST} ${TEST_SUITE_FILES})

=== Examples/Bonds/CMakeLists.txt ===
add_executable(Bonds Bonds.cpp)
target_link_libraries(Bonds ${QL_LINK_LIBRARY})

=== Examples/CVAIRS/CMakeLists.txt ===
add_executable(CVAIRS CVAIRS.cpp)
target_link_libraries(CVAIRS ${QL_LINK_LIBRARY})

=== Examples/DiscreteHedging/CMakeLists.txt ===
add_executable(DiscreteHedging DiscreteHedging.cpp)
target_link_libraries(DiscreteHedging ${QL_LINK_LIBRARY})

=== Examples/Gaussian1dModels/CMakeLists.txt ===
add_executable(Gaussian1dModels Gaussian1dModels.cpp)
target_link_libraries(Gaussian1dModels ${QL_LINK_LIBRARY})

=== Examples/LatentModel/CMakeLists.txt ===
add_executable(LatentModel LatentModel.cpp)
target_link_libraries(LatentModel ${QL_LINK_LIBRARY})

=== Examples/MarketModels/CMakeLists.txt ===
add_executable(MarketModels MarketModels.cpp)
target_link_libraries(MarketModels ${QL_LINK_LIBRARY})

=== Examples/MulticurveBootstrapping/CMakeLists.txt ===
add_executable(MulticurveBootstrapping MulticurveBootstrapping.cpp)
target_link_libraries(MulticurveBootstrapping ${QL_LINK_LIBRARY})

=== Examples/MultidimIntegral/CMakeLists.txt ===
add_executable(MultidimIntegral MultidimIntegral.cpp)
target_link_libraries(MultidimIntegral ${QL_LINK_LIBRARY})

=== debian/changelog ===
quantlib (1.17-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:28:58 +0000

quantlib (1.17-2) unstable; urgency=medium

  * debian/control: Let quantlib-example Breaks: and Replaces: and more
    recent libquantlib0v5 as we moved one manual page

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 03 Dec 2019 18:58:41 -0600

quantlib (1.17-1.1904.1) disco; urgency=medium

  * PPA build for Ubuntu 19.04 ("disco")
  * debian/control: Let quantlib-example Breaks: and Replaces: and more
    recent libquantlib0v5 as we moved one manual page

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 03 Dec 2019 18:47:08 -0600

quantlib (1.17-1.1904.0) disco; urgency=medium

  * PPA build for Ubuntu 19.04 ("disco")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 03 Dec 2019 16:23:37 -0600

quantlib (1.17-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Update Standards-Version: to current version

  * debian/control: Add 'libboost-timer-dev, libboost-system-dev' to
    Build-Depends: as they are now needed for test-suite and benchmark

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 03 Dec 2019 10:39:55 -0600

quantlib (1.16-1.1904.0) disco; urgency=medium

  * PPA build for Ubuntu 19.04 ("disco")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 06 Aug 2019 09:55:31 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: quantlib
 Section: libs
 Priority: optional
-Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, g++ (>= 4:5.2), dh-autoreconf
-Standards-Version: 4.4.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dirk Eddelbuettel <edd@debian.org>
+Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, libboost-timer-dev, libboost-system-dev, g++ (>= 4:5.2), dh-autoreconf
+Standards-Version: 4.4.1
 
 Package: libquantlib0v5
 Architecture: any
@@ -39,8 +40,8 @@
 Architecture: any
 Section: devel
 Depends: ${shlibs:Depends}, ${misc:Depends}, libquantlib0v5 (= ${binary:Version})
-Breaks: libquantlib0v5 (<< 1.11-2)
-Replaces: libquantlib0v5 (<< 1.11-2)
+Breaks: libquantlib0v5 (<< 1.17-1)
+Replaces: libquantlib0v5 (<< 1.17-1)
 Description: Quantitative Finance Library -- example binaries
  The QuantLib project aims to provide a comprehensive software framework 
  for quantitative finance. The goal is to provide a standard free/open
